/* RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and that
no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


File: postresp.c  processes the responses that are postponed until display
By: Scott Williamson
*/

#include "rwhois.h"
#include "errlist.h"

struct STATUS curr_server_status;
struct SERVER *findlink();

#ifndef atof
double atof();
#endif

post_response( retline)
  char *retline;
{
  char altcmdline[80];
  char refhost[80];
  char *ptr;
  char attrib[80], avalue[80];
  char *object_value, *type_value, *value;
  int saport, satype;
  struct SERVER *resp_server;
  char temp[80];
  int ret = WAIT_NULL;
  static char last_object[80];


  /* Start %see-also */

  if(!strncmp( retline, "%see-also", 9 ))
  {

    ret = WAIT_SEEALSO;

    if(ptr = index( retline, ' '))
    {
      if(!strncmp( ++ptr, "url", 3))
        gourl( ptr);
      else
      {

        /* grab the new query ( it is required ) */
        ptr = rindex( retline, ':');
        *(ptr++) = NullCH;

        strcpy( altcmdline, ptr);

        /* make sure that line is not term with return */
        if((ptr = index( altcmdline, '\n')))
          *ptr = NullCH;

        ptr = index( retline, ' ');
        strcpy( refhost, ++ptr);

        brk_server( refhost, &saport, &satype);

        resp_server = findlink( refhost, saport, altcmdline);
        if( resp_server)
          if( resp_server->filestatus&FILEHASDATA )
            display_second( resp_server->filename);
          else
            error("Displaying from see_also");
        else
          error("Problem with see_also information");


      }
    }
  }
  /* End %see-also */

  /* Start %soa */
  if(!strncmp( retline, "%soa", 4))
  {
    if( verbose > TALK | forcing )
    {
      sscanf( retline, "%%soa %s %s", attrib, avalue);
      printf("\nSOA - %s = %s", 
             attrib, avalue);
    }
  }

  /* Start %schema */

  if(!strncmp( retline, "%schema", 7))
  {
    if(((verbose > TALK | forcing) | edit == ON ) 
       && (index( retline, ':')))
    {

      if(!brkresponse( 3, retline, &object_value, &type_value, 
                       &value))
      {

        if(strncmp( object_value, last_object, 
                    strlen( object_value)))
        {
          strncpy( last_object, object_value, 
                   strlen( object_value));
          last_object[strlen(object_value)] = NullCH;
          printf("\nSchema for [%s] object\n\n", last_object);
        }

        upper( type_value);
        if( to_file && !strncmp( type_value, "ATTRIBUTE", 9))
        {

          if(  !f_out)
          {
            mktemp( file_name);
            f_out = fopen( file_name, "w");
          }


          fprintf(f_out, "%s:\n", value);
          goodedit = REG_ADD;

        }
        else if (!to_file)
        {
          if(!strncmp( type_value, "ATTRIBUTE", 9))
            printf("%s", value);
          if(!strncmp( type_value, "FORMAT", 6))
            printf(" [%s]", value);
          if(!strncmp( type_value, "DESCRIPTION", 11))
            printf(" - %s", value);
        }
      }
    }
    else
    {
      if( verbose > TALK || forcing  && edit != ON)
        putchar( '\n');

    }
  }

  /* Start directive */

  if(!strncmp( retline, "%directive", 10))
  {
    if((verbose > TALK ) | forcing )
    {

      if(index( retline, ':'))
      {
        if(!brkresponse( 2, retline, &type_value, 
                         &value, &object_value))
        {
          if(!strncmp( type_value, "directive", 9))
            printf("%s", value);
          if(!strncmp( type_value, "description", 11))
            printf(" (%s)", value);
          if(!strncmp( type_value, "syntax", 6))
            printf(" [%s]", value);
        }
      }
      else
        putchar( '\n');

    }
  }


  /* Start %xfer */

  if(!strncmp( retline, "%xfer", 5))
  {
    if(!brkresponse( 3, retline, &object_value, &type_value, 
                     &value))
      printf("\n%s:%s", type_value, value);
    else
      printf("\n------------------");
                

  }

  /* object */

  if(!strncmp( retline, "%object", 7))
  {
    if(!brkresponse( 3, retline, &object_value, &type_value, 
                     &value))
    {
      upper( type_value);
      if( edit == ON )
      {
        if(!strncmp( type_value, "NAME", 4))
          printf("\n%s", value);
      }
      else
        printf("\n%s:%s", type_value, value);
    }
    else if( edit != ON )
      printf("\n------------------");
                

  }


  /* display */
  if(!strncmp( retline, "%display", 7))
  {
    ret = WAIT_SOMETHING;

    if(!brkresponse(3, retline, &type_value, &value, &object_value))
    {
      printf("\nDisplay type: %s\n", value);
      upper( value);

      if(!strcmp( value, "MIME"))
        if( mimepath)
          sprintf( temp, "%s %s", mimepath, object_value);
        else
          printf("\nMime reader not configured\n");
      else if(!strcmp( value, "URL"))
        if( urlpath)
          sprintf( temp, "%s %s", urlpath, object_value);
        else
          printf("\nURL follower not configured\n");
      system( temp);
    }
  }

  return(ret);

}


