/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#ifndef _ATTRIBUTES_H_
#define _ATTRIBUTES_H_

/* includes */
#include "common.h"
#include "llist.h"
#include "types.h"


/* defines */

/* tags for parsing definitions */
#define A_ATTRIBUTE      "attribute"
#define A_ATTRIB_ALIAS   "attribute-alias"
#define A_DESCRIPTION    "description"
#define A_FORMAT         "format"
#define A_IS_PRIMARY_KEY "is-primary-key"
#define A_IS_AUTH_AREA   "is-authority-area"
#define A_IS_SOA_SERIAL  "is-soa-serial"
#define A_IS_REQUIRED    "required"
#define A_MULT_LINES     "mult-lines"
#define A_INDEX          "index"
#define A_DEF_OBJECT     "def_object"
#define A_MULTIPLE_GRP   "is-multiple-grp"
#define A_TYPE           "type"

/* for indexing */
#define A_INDEX_ALL_WORDS   "ALL"
#define A_INDEX_ONLY_WORDS  "INDEX_ONLY"
#define A_INDEX_FIRST_WORDS "FIRST"
#define A_INDEX_NONE_WORDS  "NONE"


/* attribute types */

#define A_TYPE_TEXT      "TEXT"
#define A_TYPE_FILE      "FILE"
#define A_TYPE_MIME      "MIME"
#define A_SEE_ALSO       "SEE-ALSO"
#define A_REFERRAL       "REFERRAL"


#define  INDEX_PRFX       "QWQX"


/* prototypes */

int read_attributes PROTO((object_struct *object));

int set_attribute_global_id PROTO((attribute_struct *attrib,
                                   object_struct    *object));

int set_internal_id PROTO((attribute_struct *attrib));

char *show_attribute_type PROTO((a_type type));

int get_attribute_global_id_from_txt PROTO((char *attribute_txt));

attribute_struct *get_attribute_info_from_global_id PROTO((int offset));

attribute_struct *get_attribute_info_from_internal_id PROTO((int offset));

attribute_struct *
get_attribute_info_from_name_and_object PROTO((char *object_name,
                                               char *attribute_name));

int get_id_from_object_and_name PROTO((char *object_name,
                                       char *attribute_name));

char *get_attribute_name PROTO((int id));

llist_struct *global_list_of_attributes PROTO(());

attribute_struct *set_attributes_list_from_object PROTO((int  mode,
                                                         char *tag,
                                                         char *datum));

attribute_struct *find_specific_attribute PROTO((attribute_struct *attrib,
                                                 char             *tag));

#endif /* _ATTRIBUTES_H_ */
