/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#ifndef _COMMANDS_H_
#define _COMMANDS_H_

/* includes */
#include "common.h"
#include "types.h"

/* prototypes */

void parse_out_commands PROTO((query_item_struct *query_item));

int do_commands PROTO((char *word, char *next, query_item_struct *query_item,
                       int directive_only));

void append_command PROTO((char *command, int len, char *magic,
                           char *description, int arg_required,
                           command_type type, object_struct *object,
                           int (*function)(), char *program));

object_struct *return_object_by_command PROTO((char *str));

command_struct *return_commands_by_object PROTO((char *object_str, int reset));

command_struct *return_all_commands PROTO(());

#endif /* _COMMANDS_H_ */
