/* insert std header here */
#include "define_conf.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */

#include "defines.h"
#include "log.h"
#include "misc.h"

#define D_DEFINE_MACRO "MACRO"

typedef enum {
  DEFINE_MACRO,
  UNKNOWN_DEFINE
} d_type;

/* local statics */

static define_struct *define_list = NULL;

/* returns the define type */
static d_type
get_define_type (type)
  char *type;
{
  if (STR_EQ(type, D_DEFINE_MACRO) == 0)
  {
    return (DEFINE_MACRO);
  }

  return(UNKNOWN_DEFINE);
}

/* reads the defines from a file */
int
read_define_file(file)
  char *file;

{
  FILE          *fp             = NULL;
  char          line[MAX_LINE];
  char          tag[MAX_LINE];
  char          datum[MAX_LINE];
  define_struct *new            = NULL;
  define_struct *cur            = NULL;

  if (!file || !*file) return TRUE;

  if ((fp = fopen(file, "r")) ==  NULL)
  {
    log_error("could not open define file '%s': %s", file,
              l_strerror(errno));
    return FALSE;
  }

  while ((fgets (line, MAX_LINE, fp)) != NULL)
  {
    if (new_record (line) || define_list == NULL) {

      new = NEW_DEFINE;

      if (define_list == NULL)
      {
        define_list = new;
        cur         = new;
      }
      else
      {
        cur->nxt = new;
        cur      = new;
      }
    }

    if (parse_line (line, tag, datum))
    {
      if (STR_EQ(tag, D_TYPE))
      {
        cur->type = get_define_type(datum);
      }
      else if (STR_EQ(tag, D_NAME))
      {
        cur->name = NEW_STRING(datum);
      }
      else if (STR_EQ(tag, D_VALUE))
      {
        cur->value = NEW_STRING(datum);
      }
    }
  }

  fclose(fp);
  return (TRUE);
}

define_struct *
get_define_list()
{
  return(define_list);
}
