/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#ifndef _DEFINES_H_
#define _DEFINES_H_

#include "common.h"

#ifndef TRUE
#define TRUE                1
#endif
#ifndef FALSE
#define FALSE               0
#endif

#define MAX_FILENAME        256
#define MAX_LINE            512
#define MAX_FILE            512
#define MAX_ATTRIBUTES      512
#define MAX_COMMANDS        512
#define MAX_BUF             4096
#define MAX_REFERRAL_LINES  20
#define MAX_TEMPLATE_NAME   256
#define MAX_TEMPLATE_DESC   256
#define CONTROL(char)       (char ^ 0100)
#define ABORT_CHAR          CONTROL('G')
#define STATUS_CHAR         CONTROL('E')
#define CRLF                "\015\012"
#define QUIT                2   /* this should be moved somewhere */

/* Global string manipulation macros */
/* Safe(ish) strdup. */
/* NOTE: the variable passed to this routine must be legal */
#define NEW_STRING(s)   strcpy((char *)calloc(1,(unsigned) strlen(s)+1), s)

#define NEW_STRING_SIZE(s,size) (char *)calloc(1, size + 1)

/* NOTE: the variables passed to this routine must be legal (i.e.,
   terminated) C strings */
#ifndef STR_EQ
#define STR_EQ(str1,str2) \
    (strcasecmp((char *)(str1), (char *)(str2)) ? FALSE : TRUE)
#endif /* ! STR_EQ */
#ifndef STRN_EQ
#define STRN_EQ(str1,str2,size) \
    (strncasecmp((char *)(str1), (char *)(str2), (size)) ? FALSE : TRUE)
#endif /* ! STRN_EQ */
  
/* NOTE: the 'str' variable must be a literal string or locally defined
   character array. */
#define STR_COPY(str,val) \
    strncpy((char *)(str), (char *)(val), sizeof(str) - 1)


/*
 *  global_flag-diddling macros
 */

#define SET(flag,offset)       flag = flag |= (1 << offset)
#define CLEAR(flag,offset)     flag = flag &= ~(1<<offset)
#define ON(flag,offset)        (flag & (1<<offset))
#define OFF(flag,offset)       (!(flag & (1<<offset)))

/********************************************
  flag macros for display types
********************************************/
#define DUMP_DISPLAY 1
#define FULL_DISPLAY 2
#define SUMMARY_DISPLAY 3

/********************************************
  flag macros for queries
********************************************/
#define HANDLE_QUERY 1
#define SCAN_FOR_USERS 2
#define EXIT_QUERY 3
#define HELP_QUERY 4

/********************************************
  local changes
*********************************************/

#include "conf.h"


#endif /* DEFINES */
