#include "directive_conf.h"

#include <stdio.h>
#include <string.h>
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <stdlib.h>
#include "defines.h"
#include "misc.h"
#include "commands.h"

/* read_extended_directive_file: reads the extended directives from a
      file and places them into a data structure */
int
read_extended_directive_file(file)
  char *file;
{
  FILE  *fp;
  char  line[MAX_LINE];
  char  tag[MAX_TEMPLATE_DESC];
  char  datum[MAX_TEMPLATE_DESC];
  char  description[MAX_TEMPLATE_DESC];
  char  command[MAX_TEMPLATE_DESC];
  int   command_len;
  char  program[MAX_TEMPLATE_DESC];

  if (!file || !*file) return TRUE;
  
  *command     = '\0';
  *program     = '\0';
  *description = '\0';
  command_len  = 0;

  if ((fp = fopen(file, "r")) == NULL)
  {
    return FALSE;
  }

  while ((fgets(line, MAX_LINE, fp)) != NULL)
  {
    if (new_record (line) && *command && *program) {
      if (command_len == 0)
      {
        command_len = strlen(command);
      } 

      append_command(command, command_len, NULL, description, FALSE, 
                     COMMAND_X_DIRECTIVE, NULL, NULL, program);
      
      *command    = '\0';
      *program    = '\0';
      command_len = 0;
    }
    else if (parse_line(line, tag, datum))
    {
      if (STR_EQ(tag, D_COMMAND))
      {
        sprintf(command, "X-%s", datum);
      }
      else if (STR_EQ(tag, D_COMMAND_LEN))
      {
        command_len = atoi(datum) + 2;
      }
      else if (STR_EQ(tag, D_COMMAND_DESCRIPTION))
      {
        strncpy(description, datum, MAX_TEMPLATE_DESC);
      }
      else if (STR_EQ(tag, D_COMMAND_PROGRAM))
      {
        strncpy(program, datum, MAX_TEMPLATE_DESC);
      }
    }
  }
  
  if (*command && *program)
  {
    if (command_len == 0)
    {
      command_len = strlen(command);
    }
    
    append_command(command, command_len, NULL, description, FALSE, 
                   COMMAND_X_DIRECTIVE, NULL, NULL, program);
  }

  fclose(fp);
  return (TRUE);
}
