

#ifndef _DISPLAY_CONF_H_
#define _DISPLAY_CONF_H_

/* includes */

#include "common.h"
#include "types.h"

/* defines */

#define MULTI_DISPLAY   "multi"
#define SINGLE_DISPLAY  "single"
#define ALL_DISPLAY     "all"

/* tags for parsing definitions */

#define O_COMMAND        "command"
#define O_COMMAND_LEN    "command-len"
#define O_MAGIC          "magic"
#define O_DESCRIPTION    "description"
#define O_HEADER         "header"
#define O_FOOTER         "footer"
#define O_RECORD_DELIM   "record-delim"
#define O_DEFAULT_MULTI  "default-multi"
#define O_DEFAULT_SINGLE "default-single"

/* prototypes */

int read_displays PROTO((char *config_file));

output_display_struct *
read_display_format_from_object PROTO((output_display_struct *top,
                                       char *str));

output_command_struct *return_all_defined_displays PROTO(());

char *get_display_status PROTO((char *type));

int set_display_status PROTO((char *type, char *mode));

#endif /* _DISPLAY_CONF_H_ */
