#ifndef _FILEUTILS_H_
#define _FILEUTILS_H_

/* includes */

#include <sys/types.h>
#include "common.h"

/* prototypes */

int file_exists PROTO((char *file));

int directory_exists PROTO((char *dir));

int is_rel_path PROTO((char *path));

int store_current_wd PROTO(());

int restore_current_wd PROTO(());

time_t get_path_mod_time PROTO((char *path));

char *path_full_to_rel PROTO((char *full_path, char *root_dir));

char *path_rel_to_full PROTO((char *new_path, int new_path_len,
                              char *rel_path, char *root_dir));

int canonicalize_path PROTO((char *new_path, int new_path_len,
                             char *path, char *root_dir, int chrooted,
                             int null_allowed));

char *make_timestamp PROTO(());

char *create_filename PROTO((char *fname, char *template,
                             char *spool_directory));

char *create_db_filename PROTO((char *fname, char *template,
                                char *spool_directory, char *postfix));

#endif /* _FILEUTILS_H_ */
