/************************************************************************
RWhois Software

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and
that no charge is made for such copies.

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By:
  Mark Kosters
***************************************************************************/

#ifndef _LLIST_H_
#define _LLIST_H_

/* includes */

#include "common.h"

/* types */

/* the basic list list node */
typedef struct _llist_struct
{
  void *datum;                  /* pointer to element data */
  struct _llist_struct *nxt;    /* next item on the list */
} llist_struct;

#define NEW_LINK (llist_struct *) calloc ((unsigned)1, \
  (unsigned)sizeof(llist_struct))


/* prototypes */
  
llist_struct *append_llist PROTO((llist_struct *list, void *datum));

void free_llist PROTO((llist_struct *list));

#endif /* _LLIST_H_ */
