/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#ifndef _OBJECTS_H_
#define _OBJECTS_H_

#include "common.h"
#include "types.h"

/* defines */

#define O_NAME         "name"
#define O_ATTRIBUTEDEF "attributedef"
#define O_LOCALDB      "localdb"
#define O_CACHEDB      "cachedb"
#define O_DBDIR        "dbdir"
#define O_DISPLAY      "display"
#define O_DESCRIPTION  "description"
#define O_COMMAND      "command"
#define O_TYPE         "type"

/* prototypes */

int read_objects PROTO((char *file));

llist_struct *return_objects_by_type PROTO((object_type type));

llist_struct *return_all_defined_objects PROTO((char *str));

attribute_struct *
get_object_attributes_by_object_name PROTO((char *object_name));

object_struct *get_object_by_object_name PROTO((char *object_name));

llist_struct *setup_search_objects PROTO((query_item_struct *query_item,
                                          object_type       type));

object_struct *get_object_from_record PROTO((field_struct *fields));

attribute_struct *get_object_attributes_by_tag PROTO((char *tag,
                                                      char *datum));

#endif /* _OBJECTS_H_ */
