/************************************************************************
RWhois Software

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and
that no charge is made for such copies.

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By:
  Mark Kosters
***************************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include "defines.h"
#include "fileinfo.h"
#include "hitinfo.h"
#include "strutil.h"
#include "mkdb_interface.h"

#define DEFAULT_DB_NAME "default"


/*************************************************************************
  main routine
**************************************************************************/
void
main(argc, argv)
  int  argc;
  char *argv[];

{
  char *prefix;
  char dbase_name[MAX_FILENAME];
  char str[MAX_BUF];
  int  error_code;

  *dbase_name = '\0';

  if (argc == 1)
  {
    prefix = DEFAULT_DB_NAME;
  }
  else
  {
    prefix = argv[1];
  }

  sprintf(dbase_name, "%s.db", prefix);

  printf("enter search: ");
  gets(str);

  while (*str)
  {
    printf("ok with |%s|\n", str);
/*  mkdb_interface(dbase_name, str, 1, &error_code); */
    printf("error code is %d\n", error_code);
    printf("enter search: ");
    gets(str);
    stripchar(str, '\n');
  }

#if test_getrecord
  {
    int  max_buf;
    char *buf;
    int  offset;
    int  file_no;

    printf("enter file_no: ");
    file_no = atoi(gets (str));
    printf("enter offset: ");
    offset = atoi(gets (str));
    printf("ansswer is: \n%s\ndone.\n", MKget_record(offset, file_no, buf, 
                                                     &max_buf));
  }
#endif

#if test_hits
  {
    int  search_type;
    int  comparison;
    
    printf("enter search_type: ");
    search_type = atoi(gets(str));
    printf("enter comparision: ");
    comparison = atoi(gets(str));
    printf("enter value: ");
    gets(str);
    debug_hits(search_index(0, str, search_type, comparison));
  }
#endif

}
