#ifndef _FILE_INFO_H_
#define _FILE_INFO_H_

/* includes */

#include "common.h"

#include <stdio.h>

/* defines */


/* tags for parsing definitions */
#define MKDB_TYPE       "type"
#define MKDB_FILE       "file"
#define MKDB_INDEX_NO   "index_no"
#define MKDB_SIZE       "size"
#define MKDB_NUMRECS    "num_recs"


/* for types of files */
#define MKDB_INDEX_FILE   "INDEX"
#define MKDB_DATA_FILE    "DATA"

typedef enum
{
  ENUM_INDEX_FILE,
  ENUM_DATA_FILE
} file_type;


typedef struct _mkdb_fileinfo_struct
{
  file_type type;                      /* type of file */
  char *filename;                      /* filename */
  int  index_no;                       /* index number of file */
  int  size;                           /* size of the file */
  int  num_recs;                       /* number of records in file */
  struct _mkdb_fileinfo_struct *nxt;   /* ptr to nxt record */
} mkdb_fileinfo_struct;

#define NEW_FILE_INFO (mkdb_fileinfo_struct *) calloc ((unsigned)1, \
   (unsigned)sizeof(mkdb_fileinfo_struct))

/* prototypes */

int read_fileinfo PROTO((char *filename));

mkdb_fileinfo_struct *load_fileinfo_list PROTO((FILE *fp));

void clear_fileinfo PROTO(());

void clear_fileinfo_list PROTO((mkdb_fileinfo_struct *cur));

mkdb_fileinfo_struct *get_fileinfo PROTO((file_type type, int index_no));

char *get_fileinfo_data_files PROTO((int reset));

int get_fileinfo_record_count PROTO(());

#endif /* _FILEINFO_H_ */

