/************************************************************************
RWhois Software

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and
that no charge is made for such copies.

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By:
  Mark Kosters
***************************************************************************/

/**************************************************************************
  Change history

9/13/94 Included additional col in store_hits to mention that
        element deleted (TRUE) or not (FALSE).
***************************************************************************/
#include "hitinfo.h"

#include <stdio.h>
#include <stdlib.h>

#include "defines.h"

/* local prototypes */

static void debug_hits PROTO((mkdb_hitinfo_struct *hits));

  
mkdb_hitinfo_struct *
store_hits (hits, file_no, offset, deleted)
  mkdb_hitinfo_struct   *hits;
  int                   file_no;
  long                  offset;
  int                   deleted;

{
  mkdb_hitinfo_struct   *cur    = hits;
  mkdb_hitinfo_struct   *prev   = NULL;
  mkdb_hitinfo_struct   *new    = NULL;

  if (deleted)
  {
    return (hits);
  }
  
  while (cur != NULL)
  {
    prev = cur;

    if (cur->file_no == file_no && cur->offset == offset)
    {
      return (hits);
    }

    cur = cur->nxt;
  }

  new          = NEW_HITINFO;
  new->file_no = file_no;
  new->offset  = offset;
  
  if (prev == NULL)
  {
    return (new);
  }
  
  prev->nxt = new;

  return (hits);
}


void
clear_hits (hits)
  mkdb_hitinfo_struct *hits;
{
  mkdb_hitinfo_struct *del;

  while (hits != NULL)
  {
    del  = hits;
    hits = hits->nxt;
    free(del);
  }
}

static void
debug_hits(hits)
  mkdb_hitinfo_struct *hits;
{
  while (hits != NULL)
  {
    fprintf(stderr, "file_no: |%d| ", hits->file_no);
    fprintf(stderr, "offset: |%ld|\n", hits->offset);
    hits = hits->nxt;
  }
}
