/* insert std header here */

#include "rwhois_supp.h"

#include <stdio.h>
#include <string.h>

#include "attributes.h"
#include "defines.h"
#include "misc.h"
#include "objects.h"
#include "strutil.h"

/****************************************************************************
  sets the object for the type
  Mark Kosters/InterNIC (markk@internic.net)
  Returns TRUE if to index this
          FALSE if not
****************************************************************************/
int
set_index_format(object_name, attribute_name, line, datum, pass)
  char  *object_name;
  char  *attribute_name;
  char  *line;
  char  *datum;
  int   pass;

{
  int               index_field = 0;
  int               retval      = FALSE;
  attribute_struct  *attrib     = NULL;

  *line = '\0';

  attrib = get_attribute_info_from_name_and_object(object_name,
                                                   attribute_name);

  /* if we can't find attribute info for this object, we can't index it. */
  if (!attrib)
  {
    return (FALSE);
  }

  /***
    do special things based on the attribute type
    ***/

  switch  (attrib->type)
  {
  case TYPE_TEXT:
    index_field = TRUE;
    break;
  case TYPE_FILE:
    index_field = FALSE;
    break;
  case TYPE_MIME:
    index_field = FALSE;
    break;
  case TYPE_SEE_ALSO:
    /* parse_line (datum, tmp_str2, datum); */
    index_field = TRUE;
    break;
  default:
    break;
  }

  if (index_field)
  {
    switch  (attrib->index_words)
    {
    case INDEX_ALL_WORDS:
    case INDEX_FIRST_WORD:
      ltrim (datum);
      if (pass == 0)
      {
        sprintf (line, "%d%s%s", attrib->global_id, INDEX_PRFX, datum);
        strupr (line);
        retval = TRUE;
      }
      else if (pass == 1)
      {
        strupr (strcpy (line, datum));
        retval = TRUE;
      }
      else
      {
        retval = FALSE;
      }
      break;
    case INDEX_WORD_ONLY:
      ltrim (datum);
      if (pass == 0)
      {
        sprintf (line, "%d%s%s", attrib->global_id, INDEX_PRFX,datum);
        strupr (line);
        retval = TRUE;
      }
      else
      {
        retval = FALSE;
      }
      break;
    case INDEX_NO_WORDS:
      retval = FALSE;
      break;
    }
    return (retval);
  }
  else
  {
    return (FALSE);
  }
}
