/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#include "limit.h"

#include <stdio.h>
#include <stdlib.h>

#include "client_msgs.h"
#include "conf.h"
#include "defines.h"
#include "holdconnect.h"
#include "variables.h"

static int max_hits        = -1;

/*************************************************************************
 sets the maximum hits for a particular query
**************************************************************************/
int
set_max_hit_limit(str)
  char *str;
{
  int hits;

  if ( !str || !*str || (hits = atoi(str)) < 1)
  {
    print_error(INVALID_MAXREC, "");
    return FALSE;
  }

  if (hits > get_max_hits_ceiling())
  {
    print_error(EXCEEDED_MAXREC, "");
    return FALSE;
  }

  max_hits = hits;

  print_ok();
  return TRUE;
}

/*************************************************************************
  retrieves the maximum hits for wais
**************************************************************************/
int
get_max_hit_limit()
{

  if (max_hits < 0)
  {
    /* we haven't set the default yet */
    max_hits = get_max_hits_default();
  }
  
  return(max_hits);
}

